<template lang="pug">
loader(title="Waiting for login to complete with Zoom.us...")
</template>

<script>
import { EventBus } from "@/components/event-bus.js";
import Loader from "@/components/Loader.vue";
import { auth } from "../db";

export default {
  name: "Login",
  components: { Loader },
  created: function () {
    this.signInWithToken();
  },
  methods: {
    async signInWithToken() {
      const tokenParameter = this.$route.query.token;
      // A firebase token is required as a parameter to this route
      if (!tokenParameter) {
        console.log("No token given");
        // If no token is given, send to the home page
        this.$router.push("/");
        return;
      }

      try {
        // We set the persistence so that the user will always stay logged in,
        // unless they explicitly log out
        await auth.setPersistence("local");
        await auth.signInWithCustomToken(tokenParameter);
        EventBus.$emit("logged-in");
        this.$router.push("/");
      } catch (error) {
        console.error(`${error.code}: ${error.message || error}`);
      }
    },
  },
};
</script>

<style scoped>
</style>